//
// Copyright 2023 Pixar
//
// Licensed under the Apache License, Version 2.0 (the "Apache License")
// with the following modification; you may not use this file except in
// compliance with the Apache License and the following modification to it:
// Section 6. Trademarks. is deleted and replaced with:
//
// 6. Trademarks. This License does not grant permission to use the trade
//    names, trademarks, service marks, or product names of the Licensor
//    and its affiliates, except as required to comply with Section 4(c) of
//    the License and to reproduce the content of the NOTICE file.
//
// You may obtain a copy of the Apache License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the Apache License with the above modification is
// distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied. See the Apache License for the specific
// language governing permissions and limitations under the Apache License.
//
////////////////////////////////////////////////////////////////////////

/* ************************************************************************** */
/* **                                                                      ** */
/* ** This file is generated by a script.                                  ** */
/* **                                                                      ** */
/* ** Do not edit it directly (unless it is within a CUSTOM CODE section)! ** */
/* ** Edit hdGen/schema.py instead to make changes.                        ** */
/* **                                                                      ** */
/* ************************************************************************** */

#include "pxr/imaging/hd/extComputationPrimvarSchema.h"
#include "pxr/imaging/hd/retainedDataSource.h"

#include "pxr/base/trace/trace.h"


PXR_NAMESPACE_OPEN_SCOPE

TF_DEFINE_PUBLIC_TOKENS(HdExtComputationPrimvarSchemaTokens,
    HD_EXT_COMPUTATION_PRIMVAR_SCHEMA_TOKENS);

// --(BEGIN CUSTOM CODE: Schema Methods)--
// --(END CUSTOM CODE: Schema Methods)--




HdTokenDataSourceHandle
HdExtComputationPrimvarSchema::GetInterpolation()
{
    return _GetTypedDataSource<HdTokenDataSource>(
        HdExtComputationPrimvarSchemaTokens->interpolation);
}

HdTokenDataSourceHandle
HdExtComputationPrimvarSchema::GetRole()
{
    return _GetTypedDataSource<HdTokenDataSource>(
        HdExtComputationPrimvarSchemaTokens->role);
}

HdPathDataSourceHandle
HdExtComputationPrimvarSchema::GetSourceComputation()
{
    return _GetTypedDataSource<HdPathDataSource>(
        HdExtComputationPrimvarSchemaTokens->sourceComputation);
}

HdTokenDataSourceHandle
HdExtComputationPrimvarSchema::GetSourceComputationOutputName()
{
    return _GetTypedDataSource<HdTokenDataSource>(
        HdExtComputationPrimvarSchemaTokens->sourceComputationOutputName);
}

HdTupleTypeDataSourceHandle
HdExtComputationPrimvarSchema::GetValueType()
{
    return _GetTypedDataSource<HdTupleTypeDataSource>(
        HdExtComputationPrimvarSchemaTokens->valueType);
}

/*static*/
HdContainerDataSourceHandle
HdExtComputationPrimvarSchema::BuildRetained(
        const HdTokenDataSourceHandle &interpolation,
        const HdTokenDataSourceHandle &role,
        const HdPathDataSourceHandle &sourceComputation,
        const HdTokenDataSourceHandle &sourceComputationOutputName,
        const HdTupleTypeDataSourceHandle &valueType
)
{
    TfToken _names[5];
    HdDataSourceBaseHandle _values[5];

    size_t _count = 0;
    if (interpolation) {
        _names[_count] = HdExtComputationPrimvarSchemaTokens->interpolation;
        _values[_count++] = interpolation;
    }

    if (role) {
        _names[_count] = HdExtComputationPrimvarSchemaTokens->role;
        _values[_count++] = role;
    }

    if (sourceComputation) {
        _names[_count] = HdExtComputationPrimvarSchemaTokens->sourceComputation;
        _values[_count++] = sourceComputation;
    }

    if (sourceComputationOutputName) {
        _names[_count] = HdExtComputationPrimvarSchemaTokens->sourceComputationOutputName;
        _values[_count++] = sourceComputationOutputName;
    }

    if (valueType) {
        _names[_count] = HdExtComputationPrimvarSchemaTokens->valueType;
        _values[_count++] = valueType;
    }

    return HdRetainedContainerDataSource::New(_count, _names, _values);
}


HdExtComputationPrimvarSchema::Builder &
HdExtComputationPrimvarSchema::Builder::SetInterpolation(
    const HdTokenDataSourceHandle &interpolation)
{
    _interpolation = interpolation;
    return *this;
}

HdExtComputationPrimvarSchema::Builder &
HdExtComputationPrimvarSchema::Builder::SetRole(
    const HdTokenDataSourceHandle &role)
{
    _role = role;
    return *this;
}

HdExtComputationPrimvarSchema::Builder &
HdExtComputationPrimvarSchema::Builder::SetSourceComputation(
    const HdPathDataSourceHandle &sourceComputation)
{
    _sourceComputation = sourceComputation;
    return *this;
}

HdExtComputationPrimvarSchema::Builder &
HdExtComputationPrimvarSchema::Builder::SetSourceComputationOutputName(
    const HdTokenDataSourceHandle &sourceComputationOutputName)
{
    _sourceComputationOutputName = sourceComputationOutputName;
    return *this;
}

HdExtComputationPrimvarSchema::Builder &
HdExtComputationPrimvarSchema::Builder::SetValueType(
    const HdTupleTypeDataSourceHandle &valueType)
{
    _valueType = valueType;
    return *this;
}

HdContainerDataSourceHandle
HdExtComputationPrimvarSchema::Builder::Build()
{
    return HdExtComputationPrimvarSchema::BuildRetained(
        _interpolation,
        _role,
        _sourceComputation,
        _sourceComputationOutputName,
        _valueType
    );
}


PXR_NAMESPACE_CLOSE_SCOPE