//
// Copyright 2023 Pixar
//
// Licensed under the Apache License, Version 2.0 (the "Apache License")
// with the following modification; you may not use this file except in
// compliance with the Apache License and the following modification to it:
// Section 6. Trademarks. is deleted and replaced with:
//
// 6. Trademarks. This License does not grant permission to use the trade
//    names, trademarks, service marks, or product names of the Licensor
//    and its affiliates, except as required to comply with Section 4(c) of
//    the License and to reproduce the content of the NOTICE file.
//
// You may obtain a copy of the Apache License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the Apache License with the above modification is
// distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied. See the Apache License for the specific
// language governing permissions and limitations under the Apache License.
//
////////////////////////////////////////////////////////////////////////

/* ************************************************************************** */
/* **                                                                      ** */
/* ** This file is generated by a script.                                  ** */
/* **                                                                      ** */
/* ** Do not edit it directly (unless it is within a CUSTOM CODE section)! ** */
/* ** Edit hdGen/schema.py instead to make changes.                        ** */
/* **                                                                      ** */
/* ************************************************************************** */

#include "pxr/imaging/hd/materialNodeSchema.h"

#include "pxr/imaging/hd/retainedDataSource.h"

#include "pxr/base/trace/trace.h"

// --(BEGIN CUSTOM CODE: Includes)--
// --(END CUSTOM CODE: Includes)--

PXR_NAMESPACE_OPEN_SCOPE

TF_DEFINE_PUBLIC_TOKENS(HdMaterialNodeSchemaTokens,
    HD_MATERIAL_NODE_SCHEMA_TOKENS);

// --(BEGIN CUSTOM CODE: Schema Methods)--
// --(END CUSTOM CODE: Schema Methods)--

HdMaterialNodeParameterContainerSchema
HdMaterialNodeSchema::GetParameters()
{
    return HdMaterialNodeParameterContainerSchema(_GetTypedDataSource<HdContainerDataSource>(
        HdMaterialNodeSchemaTokens->parameters));
}

HdMaterialConnectionVectorContainerSchema
HdMaterialNodeSchema::GetInputConnections()
{
    return HdMaterialConnectionVectorContainerSchema(_GetTypedDataSource<HdContainerDataSource>(
        HdMaterialNodeSchemaTokens->inputConnections));
}

HdTokenDataSourceHandle
HdMaterialNodeSchema::GetNodeIdentifier()
{
    return _GetTypedDataSource<HdTokenDataSource>(
        HdMaterialNodeSchemaTokens->nodeIdentifier);
}

HdContainerDataSourceHandle
HdMaterialNodeSchema::GetRenderContextNodeIdentifiers()
{
    return _GetTypedDataSource<HdContainerDataSource>(
        HdMaterialNodeSchemaTokens->renderContextNodeIdentifiers);
}

HdContainerDataSourceHandle
HdMaterialNodeSchema::GetNodeTypeInfo()
{
    return _GetTypedDataSource<HdContainerDataSource>(
        HdMaterialNodeSchemaTokens->nodeTypeInfo);
}

/*static*/
HdContainerDataSourceHandle
HdMaterialNodeSchema::BuildRetained(
        const HdContainerDataSourceHandle &parameters,
        const HdContainerDataSourceHandle &inputConnections,
        const HdTokenDataSourceHandle &nodeIdentifier,
        const HdContainerDataSourceHandle &renderContextNodeIdentifiers,
        const HdContainerDataSourceHandle &nodeTypeInfo
)
{
    TfToken _names[5];
    HdDataSourceBaseHandle _values[5];

    size_t _count = 0;

    if (parameters) {
        _names[_count] = HdMaterialNodeSchemaTokens->parameters;
        _values[_count++] = parameters;
    }

    if (inputConnections) {
        _names[_count] = HdMaterialNodeSchemaTokens->inputConnections;
        _values[_count++] = inputConnections;
    }

    if (nodeIdentifier) {
        _names[_count] = HdMaterialNodeSchemaTokens->nodeIdentifier;
        _values[_count++] = nodeIdentifier;
    }

    if (renderContextNodeIdentifiers) {
        _names[_count] = HdMaterialNodeSchemaTokens->renderContextNodeIdentifiers;
        _values[_count++] = renderContextNodeIdentifiers;
    }

    if (nodeTypeInfo) {
        _names[_count] = HdMaterialNodeSchemaTokens->nodeTypeInfo;
        _values[_count++] = nodeTypeInfo;
    }
    return HdRetainedContainerDataSource::New(_count, _names, _values);
}

HdMaterialNodeSchema::Builder &
HdMaterialNodeSchema::Builder::SetParameters(
    const HdContainerDataSourceHandle &parameters)
{
    _parameters = parameters;
    return *this;
}

HdMaterialNodeSchema::Builder &
HdMaterialNodeSchema::Builder::SetInputConnections(
    const HdContainerDataSourceHandle &inputConnections)
{
    _inputConnections = inputConnections;
    return *this;
}

HdMaterialNodeSchema::Builder &
HdMaterialNodeSchema::Builder::SetNodeIdentifier(
    const HdTokenDataSourceHandle &nodeIdentifier)
{
    _nodeIdentifier = nodeIdentifier;
    return *this;
}

HdMaterialNodeSchema::Builder &
HdMaterialNodeSchema::Builder::SetRenderContextNodeIdentifiers(
    const HdContainerDataSourceHandle &renderContextNodeIdentifiers)
{
    _renderContextNodeIdentifiers = renderContextNodeIdentifiers;
    return *this;
}

HdMaterialNodeSchema::Builder &
HdMaterialNodeSchema::Builder::SetNodeTypeInfo(
    const HdContainerDataSourceHandle &nodeTypeInfo)
{
    _nodeTypeInfo = nodeTypeInfo;
    return *this;
}

HdContainerDataSourceHandle
HdMaterialNodeSchema::Builder::Build()
{
    return HdMaterialNodeSchema::BuildRetained(
        _parameters,
        _inputConnections,
        _nodeIdentifier,
        _renderContextNodeIdentifiers,
        _nodeTypeInfo
    );
} 

PXR_NAMESPACE_CLOSE_SCOPE