//
// Copyright 2023 Pixar
//
// Licensed under the Apache License, Version 2.0 (the "Apache License")
// with the following modification; you may not use this file except in
// compliance with the Apache License and the following modification to it:
// Section 6. Trademarks. is deleted and replaced with:
//
// 6. Trademarks. This License does not grant permission to use the trade
//    names, trademarks, service marks, or product names of the Licensor
//    and its affiliates, except as required to comply with Section 4(c) of
//    the License and to reproduce the content of the NOTICE file.
//
// You may obtain a copy of the Apache License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the Apache License with the above modification is
// distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied. See the Apache License for the specific
// language governing permissions and limitations under the Apache License.
//
////////////////////////////////////////////////////////////////////////

/* ************************************************************************** */
/* **                                                                      ** */
/* ** This file is generated by a script.                                  ** */
/* **                                                                      ** */
/* ** Do not edit it directly (unless it is within a CUSTOM CODE section)! ** */
/* ** Edit hdGen/schema.py instead to make changes.                        ** */
/* **                                                                      ** */
/* ************************************************************************** */

#include "pxr/usdImaging/usdImaging/directMaterialBindingSchema.h"
#include "pxr/imaging/hd/retainedDataSource.h"

#include "pxr/base/trace/trace.h"

// --(BEGIN CUSTOM CODE: Includes)--
// --(END CUSTOM CODE: Includes)--

PXR_NAMESPACE_OPEN_SCOPE

TF_DEFINE_PUBLIC_TOKENS(UsdImagingDirectMaterialBindingSchemaTokens,
    USD_IMAGING_DIRECT_MATERIAL_BINDING_SCHEMA_TOKENS);

// --(BEGIN CUSTOM CODE: Schema Methods)--
// --(END CUSTOM CODE: Schema Methods)--




HdPathDataSourceHandle
UsdImagingDirectMaterialBindingSchema::GetMaterialPath()
{
    return _GetTypedDataSource<HdPathDataSource>(
        UsdImagingDirectMaterialBindingSchemaTokens->materialPath);
}

HdTokenDataSourceHandle
UsdImagingDirectMaterialBindingSchema::GetBindingStrength()
{
    return _GetTypedDataSource<HdTokenDataSource>(
        UsdImagingDirectMaterialBindingSchemaTokens->bindingStrength);
}

/*static*/
HdContainerDataSourceHandle
UsdImagingDirectMaterialBindingSchema::BuildRetained(
        const HdPathDataSourceHandle &materialPath,
        const HdTokenDataSourceHandle &bindingStrength
)
{
    TfToken _names[2];
    HdDataSourceBaseHandle _values[2];

    size_t _count = 0;
    if (materialPath) {
        _names[_count] = UsdImagingDirectMaterialBindingSchemaTokens->materialPath;
        _values[_count++] = materialPath;
    }

    if (bindingStrength) {
        _names[_count] = UsdImagingDirectMaterialBindingSchemaTokens->bindingStrength;
        _values[_count++] = bindingStrength;
    }

    return HdRetainedContainerDataSource::New(_count, _names, _values);
}

/*static*/
UsdImagingDirectMaterialBindingSchema
UsdImagingDirectMaterialBindingSchema::GetFromParent(
        const HdContainerDataSourceHandle &fromParentContainer)
{
    return UsdImagingDirectMaterialBindingSchema(
        fromParentContainer
        ? HdContainerDataSource::Cast(fromParentContainer->Get(
                UsdImagingDirectMaterialBindingSchemaTokens->directMaterialBinding))
        : nullptr);
}

/*static*/
const TfToken &
UsdImagingDirectMaterialBindingSchema::GetSchemaToken()
{
    return UsdImagingDirectMaterialBindingSchemaTokens->directMaterialBinding;
}

/*static*/
const HdDataSourceLocator &
UsdImagingDirectMaterialBindingSchema::GetDefaultLocator()
{
    static const HdDataSourceLocator locator(GetSchemaToken());
    return locator;
} 
UsdImagingDirectMaterialBindingSchema::Builder &
UsdImagingDirectMaterialBindingSchema::Builder::SetMaterialPath(
    const HdPathDataSourceHandle &materialPath)
{
    _materialPath = materialPath;
    return *this;
}

UsdImagingDirectMaterialBindingSchema::Builder &
UsdImagingDirectMaterialBindingSchema::Builder::SetBindingStrength(
    const HdTokenDataSourceHandle &bindingStrength)
{
    _bindingStrength = bindingStrength;
    return *this;
}

HdContainerDataSourceHandle
UsdImagingDirectMaterialBindingSchema::Builder::Build()
{
    return UsdImagingDirectMaterialBindingSchema::BuildRetained(
        _materialPath,
        _bindingStrength
    );
}


PXR_NAMESPACE_CLOSE_SCOPE